from chrominance.components import Node, Type


def build_modifier(type_, value):
    def wrapper(self, *children, **kwargs):
        if self.enabled:
            return Node(type_, value, *children, **kwargs)

        return ''.join(children)

    return wrapper


class Context(object):
    def __init__(self):
        self.enabled = True

    black = build_modifier(Type.FOREGROUND, 0)
    red = build_modifier(Type.FOREGROUND, 1)
    green = build_modifier(Type.FOREGROUND, 2)
    yellow = build_modifier(Type.FOREGROUND, 3)
    blue = build_modifier(Type.FOREGROUND, 4)
    magenta = build_modifier(Type.FOREGROUND, 5)
    cyan = build_modifier(Type.FOREGROUND, 6)
    white = build_modifier(Type.FOREGROUND, 7)

    bold = build_modifier(Type.MODIFIER, 1)
    blink = build_modifier(Type.MODIFIER, 5)

